<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "https://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
<meta http-equiv="X-UA-Compatible" content="IE=9"/>
<meta name="generator" content="Doxygen 1.9.1"/>
<meta name="viewport" content="width=device-width, initial-scale=1"/>
<title>AlarmScreenNg: Filter completers</title>
<link href="tabs.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="jquery.js"></script>
<script type="text/javascript" src="dynsections.js"></script>
<link href="doxygen.css" rel="stylesheet" type="text/css" />
</head>
<body>
<div id="top"><!-- do not remove this div, it is closed by doxygen! -->
<div id="titlearea">
<table cellspacing="0" cellpadding="0">
 <tbody>
 <tr style="height: 56px;">
  <td id="projectalign" style="padding-left: 0.5em;">
   <div id="projectname">AlarmScreenNg
   &#160;<span id="projectnumber">0.9.2</span>
   </div>
  </td>
 </tr>
 </tbody>
</table>
</div>
<!-- end header part -->
<!-- Generated by Doxygen 1.9.1 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.html"><span>Main&#160;Page</span></a></li>
      <li class="current"><a href="pages.html"><span>Related&#160;Pages</span></a></li>
    </ul>
  </div>
<div id="nav-path" class="navpath">
  <ul>
<li class="navelem"><a class="el" href="page_References.html">References</a></li>  </ul>
</div>
</div><!-- top -->
<div class="PageDoc"><div class="header">
  <div class="headertitle">
<div class="title">Filter completers </div>  </div>
</div><!--header-->
<div class="contents">
<div class="textblock"><p>In some cases the list of possible values (strings) for particular alarm property is fixed, and can be even known in advance. The individual <a class="el" href="pageUsingAS.html#anchorEditableFilters">filter</a> for such property can use apriori known list of possible values in two ways: </p><ul>
<li>
Use combo box where user can only select one of possible values </li>
<li>
Use the <b>completer</b> for text field where user can type the criteria. This appears as a list of proposed completions for string entered by user </li>
</ul>
<p>In either case, for this to work, the filter widget shal know possible values for this particular alarm property. In sumple cases list of possible values can be just hardcoded in plugin that builds widgets for structured filter (see <a class="el" href="page_RefJson.html#subsec_RefJsonBasicConfigFilterWidget">FilterWidget</a>). Example can be a boolean property with possible values YES/NO.</p>
<p>However, there are cases where list of possible values is not known until runtime. The example of such list is JCOP device types, which can differ from one project to another. In order to support building completions list at run time, AS EWO uses dedicated items in <a class="el" href="page_RefJson.html#subsec_RefJsonBasicConfigFilterWidget">basic configuration</a>. This sections of document describes briefly the way filter completers can be built at run time.</p>
<h1><a class="anchor" id="sec_RefFilterCompleterTypes"></a>
Completion types</h1>
<p>There are two major types of filter completers, which affect the way the lists for completion shall be built: </p><ul>
<li>
<b>Master</b> completers: the list of possible values for this alarm property is fixed, in a sense that possible values do not depend on setting of filter for another alarm property. The example can be device types in the project, which is just fixed.  </li>
<li>
<b>Slave</b> completers: the list of possible values for this alarm property depends on filter setting for another property. Imagine configuration where alarm property include the rack, where device controller is placed, and the building where that rack is located. If both building and rack appear in filter widgets, then it looks natural to perform filtering in two steps: <ul>
<li>
First select particular building - from the list of known buildings </li>
<li>
Then select one of racks in <b>selected</b> building </li>
</ul>
In such situation list of possible racks for filtering shall depend on what building was selected, and the list of racks shall be refreshed every time new building is selected.<br  />
 Such 'hierarchical' selection may contain more than just 2 levels - one can imagine that particular controller in rack is also alarm property, and filter on controller is added. Then list of controllers for selection filter shall (may?) depend on selected rack.  </li>
</ul>
<p>The <a class="el" href="page_RefJson.html#subsec_RefJsonBasicConfigFilterWidget">basic configuration</a> contains different CTRL functions for building the lists of possible values for these two types of completers. The functions are supposed to be written in CTRL language and placed in some CTRL library (the name of library is also a part of configuration). These CTRL functions will be called directly from C++ code of AS EWO when EWO needs to build a completions list for certain filter. One can not expect that functions will be called only once (for example, when UI start) - they can be called at any moment during EWO's lifecycle.</p>
<p>The following secions describe API and expected functionalify for these two functions. There are constants <code>AS_FILTER_COMPLETION_KEY_xxx</code> declared in CTRL library AlarmScreenNg.ctl and <code>enum FilterCompletionsType</code> declared in the same library.</p>
<h1><a class="anchor" id="sec_RefFilterCompleterMaster"></a>
Completions list for master</h1>
<p>The CTRL function to get a list of possible completions for master completer must have the following signature:</p>
<div class="fragment"><div class="line">mapping <span class="keyword">function</span>(<span class="keywordtype">string</span> sPropName, <span class="keyword">const</span> dyn_string &amp;dsSelectedSystems);</div>
</div><!-- fragment --><p>Two arguments are passed to this functions: </p><ul>
<li>
<b>sPropName</b>: the name of <a class="el" href="page_AlarmProp.html">alarm property</a> for which completions are requested.  </li>
<li>
<b>dsSelectedSystems</b>: The list of system names to which AS EWO is now connected. In principle, the list of completions may depend on connected systems, for example: the list of available device types can be different in different systems. It is responsability of this function to decide if returned list of completions shall depend on connected systems or not, AS EWO itself doesn't make any assuptions on usage of this argument.  </li>
</ul>
<p>The function must return <code>mapping</code> with the following keys of type <code>string</code> (see constants <code>AS_FILTER_COMPLETION_KEY_xxx</code> declared in CTRL library AlarmScreenNg.ctl): </p><ul>
<li>
<b>type</b>: the value must be <code>int</code> containing the type of result, see <code>enum FilterCompletionsType</code> declared in the same CTRL library. This key must always be present in returned result, it determines what other keys are expected to appear in returned <code>mapping</code> and how AS EWO shall interpet the values for those other keys.  </li>
<li>
<b>list</b>: the value must be <code>dyn_string</code>. This key in mapping must be present for two possible values of <b>type</b> member, but content and interpretation of result by AS EWO are completely different for these cases: <ul>
<li>
If <b>type</b> member of <code>mapping</code> is <b>Static</b> (value 1), then the list is intepreted as ready to use list of completions for filter widget.  </li>
<li>
If f <b>type</b> member of <code>mapping</code> is <b>Dynamic</b> (value 2), then the returned value is interpred as 'in order to find completions for filter on this property, I need to know seeting(s) of filter(s) for other properties'. The returned strings are interpreted by AS EWO as names of other alarm properties, whose filter settings are required to find the result. In such case AS EWO will call another <a class="el" href="page_RefFilterCompleters.html#sec_RefFilterCompleterSlave">function</a> with settings for requested filter(s).  </li>
</ul>
</li>
<li>
<b>map</b>: the value must be <code>mapping</code>; this key is expected in result of function call if <b>type</b> member of <code>mapping</code> is <b>SysRelated</b> (value 3). The <code>mapping</code> is expected to contain: <ul>
<li>
keys are <code>string</code>s: names of systems </li>
<li>
values are <code>dyn_string</code>: list of completions that shall be shown when this system is connected </li>
</ul>
This type of result is used in situation when the list of completions shall depend on connected systems, but the list for every system is known, even if that system is not connected now (see <b>dsSelectedSystems</b> argument).  </li>
</ul>
<dl class="section note"><dt>Note</dt><dd>If the value of <b>type</b> key in returned <code>mapping</code> is <b>None</b> (value 0), then other keys are ignored by AS EWO, even if they are present in returned result.</dd></dl>
<h1><a class="anchor" id="sec_RefFilterCompleterSlave"></a>
Completions list for slave</h1>
<p>The CTRL function to get a list of possible completions for slave completer must have the following signature:</p>
<div class="fragment"><div class="line">mapping <span class="keyword">function</span>(<span class="keywordtype">string</span> sPropName, <span class="keyword">const</span> mapping &amp;mFilters);</div>
</div><!-- fragment --><p>Two arguments are passed to this function: </p><ul>
<li>
<b>sPropName</b>: the name of <a class="el" href="page_AlarmProp.html">alarm property</a> for which completions are requested.  </li>
<li>
<b>mFilters</b>: the values of filters for all alarm properties, which 'masters' for filter on this alarm property. The <code>mappng</code> contains: <ul>
<li>
key: <code>string</code> with the name of <a class="el" href="page_AlarmProp.html">alarm property</a> that was returned by <a class="el" href="page_RefFilterCompleters.html#sec_RefFilterCompleterMaster">previous</a> functions as a name of master.  </li>
<li>
value: <code>string</code> with current value of filter for this property </li>
</ul>
It is not guaranteed that filters for all alarm properties, returned by call to <a class="el" href="page_RefFilterCompleters.html#sec_RefFilterCompleterMaster">previous</a> function, are present in this mapping. It is not guaranteed that values for all filters in this <code>mapping</code> are not empty. The AS EWO just passes to this function all the information it knows at this moment, then it is responsability of this function to decide what to do with (potentially) incomplete input argument.  </li>
</ul>
<p>The <code>mapping</code>, returned by this function, must containe the only key of type <code>string</code>: <b>list</b>. The value for this key must be <code>dyn_string</code>, containing possible completions for filter. </p>
</div></div><!-- contents -->
</div><!-- PageDoc -->
<!-- start footer part -->
<hr class="footer"/><address class="footer"><small>
Generated by&#160;<a href="https://www.doxygen.org/index.html"><img class="footer" src="doxygen.svg" width="104" height="31" alt="doxygen"/></a> 1.9.1
</small></address>
</body>
</html>
